#!/usr/bin/perl

###########################################################################
# GRAPHICOUNT                                                 Version 1.1 #
# Written by Patrick Dingle                     dimension@cgiworkshop.com #
# Released February 5, 1999                 A Product of The CGI Workshop #
# ----------------------------------------------------------------------- #
# The CGI Workshop:                            http://www.cgiworkshop.com #
# ----------------------------------------------------------------------- #
# Copyright (c) 1999 Patrick Dingle, All Rights Reserved.  This program   #
# may not be modified or redistributed in any way without the expressed   #
# consent of Patrick Dingle, with the exception of the marked portions.   #
# This program is provided AS IS.  Neither Patrick Dingle nor The CGI     #
# Workshop is responsible for any damaged caused, directly or indirectly, #
# by the usage of this program. This notice must remain in place under    #
# all circumstances.                                                      #
###########################################################################

###########################################################################
# You may modify the following global constant variables

# ***** ALLOW SCRIPT TO BE RUN FROM OTHER SERVERS? *****
# If you would like your script to be run from other servers besides the
# one that the script presides, set this option to 1.  If you would like
# the script only to run from the server where the script presides, set
# this option to 0.  If set to 1, anyone can execute the counter from any
# site on the entire Internet.

$allow_foreign_executions = "0";

# ***** LOCATION & NAME OF DATA FILE *****
# The location and name of the data file (The path is not necessary if the
# data file is located in the same directory as this script.)

$counterfile = "graphicount.dat";

# ***** LOCATION & NAME OF DEFAULT FONT FILE *****
# The location and name of the font file that you wish to be the default
# font.  Font files must be a file downloaded from The CGI Workshop.
# Other font files WILL NOT function.  (The path is not necessary if the
# data file is located in the same directory as this script.)

$fontfile = "default.gcf";

# ***** DEFAULT FOREGROUND COLOR *****
# The default foreground color.  Specify the color in the same way as with
# HTML, without any pound (#) symbol.

$default_foregroundcolor = "00FFFF";

# ***** DEFAULT BACKGROUND COLOR *****
# The default background color.  Specify the color in the same way as with
# HTML, without any pound (#) symbol.

$default_backgroundcolor = "000000";

# ***** DEFAULT BORDER COLOR *****
# The default border color.  Specify the color in the same way as with
# HTML, without any pound (#) symbol.

$default_bordercolor = "FF0000";

# ***** DEFAULT BORDER WIDTH *****
# The default border width (pixels).  Specify the width using with a
# positive integer (no decimals or negative numbers).

$default_border_width = "2";

#                     End of global variable settings                     #
# ********************* DO NOT EDIT BELOW THIS LINE ********************* #
###########################################################################


$file = 1;

$server_name = $ENV{'SERVER_NAME'};
$http_referer = $ENV{'HTTP_REFERER'};

if ($allow_foreign_executions eq "0")
{
	($one, $two) = split(/\:\/\//, $http_referer);
	($two, $one) = split(/\//, $two);
	$two = reverse ($two);
	$three = reverse ($server_name);
	($one, $two) = split(/\./, $two);
	($one, $three) = split(/\./, $three);
	($two, $one) = split(/\./, $two);
	($three, $one) = split(/\./, $three);
	$referer_name = reverse ($two);
	$server_name = reverse ($three);

	if ($server_name ne $referer_name)
	{
		exit;
	}
}

while ($file eq 1)
{
	if (open(TEMPFILE, "~gc-temp.tmp")) {
		close (TEMPFILE);
	}
	else {
		$file = 0;
	}
}

open(TEMPFILE, ">~gc-temp.tmp");
close(TEMPFILE);

use GD;

if ($default_border_width < 1)
{
	$default_border_width = 1;
	$default_bordercolor = $default_backgroundcolor;
}

$query = $ENV{QUERY_STRING};

$pagepath = $ENV{'DOCUMENT_URI'};

print "Content-type: image/gif\n\n";

$num = 0;
$back = reverse ($query);
for ($x = 1; $x <= length($query); $x++)
{
	$char = chop($back);
	if ($char eq "&")
	{
		$num++;
		$command[$num] = $str;
		$str = "";
	}
	else
	{
		$str = $str . $char;
	}
}
$num++;
$command[$num] = $str;

for ($x = 1; $x <= $num; $x++)
{
	($v1, $v2) = split(/\=/, $command[$x]);
	$com{$v1} = $v2;
}

if ($com{fontfile}) { $fontfile = $com{fontfile}; }
if ($com{bordersize}) { $default_border_width = $com{bordersize}; }
if ($com{bordercolor}) { $default_bordercolor = $com{bordercolor}; }
if ($com{bordersize} eq 0) { $default_border_width = 0; }
if ($com{foregroundcolor}) { $default_foregroundcolor = $com{foregroundcolor}; }
if ($com{backgroundcolor}) { $default_backgroundcolor = $com{backgroundcolor}; }

if ($default_border_width < 0) { $default_border_width = 2; }

$back = reverse ($default_foregroundcolor);
for ($x = 1; $x <= 6; $x++)
{
	$char = chop($back);
	if ($char eq "A") { $char = 10; }
	if ($char eq "B") { $char = 11; }
	if ($char eq "C") { $char = 12; }
	if ($char eq "D") { $char = 13; }
	if ($char eq "E") { $char = 14; }
	if ($char eq "F") { $char = 15; }
	
	$g[$x] = $char;
}
$default_foregroundcolor_red = $g[1] * 16 + $g[2];
$default_foregroundcolor_green = $g[3] * 16 + $g[4];
$default_foregroundcolor_blue = $g[5] * 16 + $g[6];

$back = reverse ($default_backgroundcolor);
for ($x = 1; $x <= 6; $x++)
{
	$char = chop($back);
	if ($char eq "A") { $char = 10; }
	if ($char eq "B") { $char = 11; }
	if ($char eq "C") { $char = 12; }
	if ($char eq "D") { $char = 13; }
	if ($char eq "E") { $char = 14; }
	if ($char eq "F") { $char = 15; }
	
	$g[$x] = $char;
}
$default_backgroundcolor_red = $g[1] * 16 + $g[2];
$default_backgroundcolor_green = $g[3] * 16 + $g[4];
$default_backgroundcolor_blue = $g[5] * 16 + $g[6];

$back = reverse ($default_bordercolor);
for ($x = 1; $x <= 6; $x++)
{
	$char = chop($back);
	if ($char eq "A") { $char = 10; }
	if ($char eq "B") { $char = 11; }
	if ($char eq "C") { $char = 12; }
	if ($char eq "D") { $char = 13; }
	if ($char eq "E") { $char = 14; }
	if ($char eq "F") { $char = 15; }
	
	$g[$x] = $char;
}
$default_bordercolor_red = $g[1] * 16 + $g[2];
$default_bordercolor_green = $g[3] * 16 + $g[4];
$default_bordercolor_blue = $g[5] * 16 + $g[6];



# Ensure that the document exists; creates a new one if it does not
if(open(FILE, ">>$counterfile"))
{
	close(FILE);
}

if(open(FILE, "$counterfile"))
{
	@indata = <FILE>;
	close(FILE);
}

if (!@indata)
{
	$indata[0] = "$http_referer|0\n";
}

$onoff = 0;
if(open(FILE, ">$counterfile"))
{

$numlines = 0;
foreach $temp (@indata)
{
	$numlines++;
	($ref, $count) = split(/\|/, $temp);
	if ($ref eq $http_referer)
	{
		$onoff = 1;
	}
}

if ($onoff eq 0)
{
	$indata[$numlines] = "$http_referer|0\n";
}

foreach $temp (@indata)
{
	chop($temp);
	($ref, $count) = split(/\|/, $temp);
	if ($ref eq $http_referer) {
		$count++;
		$onoff = 1;
		print FILE "$http_referer|$count\n";

		if (open(FONTFILE, "$fontfile"))
		{
			@fontdata = <FONTFILE>;
			close (FONTFILE);

			$linenum = 0;
			foreach $lineofdata (@fontdata)
			{
				chop($lineofdata);
				$linenum++;
				if ($linenum eq 1)
				{
					$rows = $lineofdata;
				}
				elsif ($linenum >= 2)
				{
					($cols[($linenum - 1)], $digits[($linenum - 1)]) = split(/\|/, $lineofdata);
				}
			}

			$count = "$count";
			$countlength = length($count);
			for ($loop = 1; $loop <= $countlength; $loop++)
			{
				$countdigit[($countlength + 1) - $loop] = chop($count);
			}

			for ($dig = 1; $dig <= $countlength; $dig++)
			{
				$digit = $countdigit[$dig];
				$fontpixels = reverse($digits[($digit+1)]);
				
				for ($rownumber = 1; $rownumber <= $rows; $rownumber++)
				{
					for ($lineofpixels = 1; $lineofpixels <= $cols[($digit+1)]; $lineofpixels++)
					{
						$line[$rownumber] = $line[$rownumber] . chop($fontpixels);
					}
					$line[$rownumber] = $line[$rownumber] . "9";
				}
			}

			for ($x = 1; $x <= $rows; $x++)
			{
				chop($line[$x]);
			}
			

			$image = new GD::Image (length($line[1]) + 2 + $default_border_width * 2, $rows + 2 + $default_border_width * 2);
						
			$bordercolor = $image->colorAllocate($default_bordercolor_red, $default_bordercolor_green, $default_bordercolor_blue);
			for ($c = 1; $c <= 10; $c++)
			{
				$red = $default_foregroundcolor_red - int((($default_foregroundcolor_red - $default_backgroundcolor_red) / 10) * $c + 0.5);
				$green = $default_foregroundcolor_green - int((($default_foregroundcolor_green - $default_backgroundcolor_green) / 10) * $c + 0.5);
				$blue = $default_foregroundcolor_blue - int((($default_foregroundcolor_blue - $default_backgroundcolor_blue) / 10) * $c + 0.5);
				$color[$c] = $image->colorAllocate($red, $green, $blue);
			}

			$image->fill(1,1,$color[10]);

			for ($x = 1; $x <= $rows; $x++)
			{
				$row = reverse ($line[$x]);
				for ($y = 1; $y <= length($line[$x]); $y++)
				{
					$c = chop($row);
					$image->setPixel($y + $default_border_width, $x + $default_border_width, ($color[$c+1]));
				}
			}

			for ($border = 0; $border <= ($default_border_width - 1); $border++)
			{
				$image->rectangle($border, $border, (length($line[1])+1+$default_border_width*2-$border), ($rows+1+$default_border_width*2-$border), $bordercolor);
			}
			$imagedata = $image->gif;
			print $image->gif;

		}
	}
	else
	{
		print FILE "$ref|$count\n";
	}
}

close(FILE);
}

unlink "~gc-temp.tmp";